﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.3.2 - Core
-- Meranannon - Insane - Vol'jin (EU)
-- rev 2
----------------------------------------------------------------------------------------------------

-- namespace
local DF = DF_namespace
local oldTalent = nil
local inspectTalent = true
local DFfirstoptions=true
local kickmsg=""
local version, build, _, tocversionNumber = GetBuildInfo()

-- cadre qui recoit event
DFeventFrame = CreateFrame("FRAME","DFeventFrame",UIParent)

---- events et scripts
function DF:setUp()

		-- events
	DFeventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	DFeventFrame:SetScript("OnEvent", DF.OnEvent)
	
end

-- init frames
function DF:init_frames()
	-- création objets ou màj
	DF:init_anchor_frame()
	DF:init_powerbar_frame()
	DF:init_healthbar_frame()
	DF:init_manabar_frame()
	DF:init_eclipsebar_frame()
	DF:init_targetbar_frame()
	DF:init_defensebar_frame()
	DF:init_threatbar_frame()
	DF:init_spells_list()
	DF:init_icons_frame()
	DF:init_timerbars_frame()
	DF:init_combo_frame()
	DF:init_arrows_frame()
	DF:init_alert_frame()
	DF:init_cooldown_frame()	
	DF:init_blood_frame()
	DF:init_infos_frame()
	DF:init_portrait_frame()
	DF:init_gps_frame()
	DF:init_castbar_frame()
	DF:init_ooc_frame()
	--DF:init_dottimer_frame()

end

function DF:core_CheckItemCD(itemId)
	local nbSpells = getn(DF_config.spells)
	
	for iccd = 1,nbSpells do
		local nbIds = getn(DF_config.spells[iccd].ids)
		for iccdid = 1,nbIds do
			if (DF_config.spells[iccd].ids[iccdid]==itemId) then
				return iccd
			end
		end
	end
	return nil
end

function DF:OnEvent(...)

	local eventArg
	local arg1
	local arg2
	local arg3
	local arg4
	local arg5
	local arg6
	local arg7
	local arg8
	local arg9
	local arg10
	local arg11
	local arg12
	local arg13
	local arg14
	local arg15
	local arg16
	local arg17
	local arg18
	
	if tocversionNumber>=40200 then
		-- 4.2
		eventArg=select(1,...)
		arg1=select(2,...)
		arg2=select(3,...)
		arg3=select(5,...)
		arg4=select(6,...)
		arg5=select(7,...)
		arg6=select(9,...)
		arg7=select(10,...)
		arg8=select(11,...)
		arg9=select(13,...)
		arg10=select(14,...)
		arg11=select(15,...)
		arg12=select(16,...)
		arg13=select(17,...)
		arg14=select(18,...)
		arg15=select(19,...)
		arg16=select(20,...)
		arg17=select(21,...)
		arg18=select(22,...)
	else
		-- 4.1
		eventArg=select(1,...)
		arg1=select(2,...)
		arg2=select(3,...)
		arg3=select(5,...)
		arg4=select(6,...)
		arg5=select(7,...)
		arg6=select(8,...)
		arg7=select(9,...)
		arg8=select(10,...)
		arg9=select(11,...)
		arg10=select(12,...)
		arg11=select(13,...)
		arg12=select(14,...)
		arg13=select(15,...)
		arg14=select(16,...)
		arg15=select(17,...)
		arg16=select(18,...)
		arg17=select(19,...)
		arg18=select(20,...)
	end

	if(eventArg == "PLAYER_ENTERING_WORLD") then
		
		DF.playerId = UnitGUID("player")
		DF.playerLevel = UnitLevel("player")
		DF.activeTalent = GetActiveTalentGroup()
		
		DF.screenHeight = GetScreenHeight()
		DF.screenWidth = GetScreenWidth()
		
		DF.uiAlwaysShow=true

		if (DFfirstoptions==true) then
			-- ligne de comm
			SLASH_DroodFocusSL1 = "/df";
			SLASH_DroodFocusSL2 = "/droodfocus";
			SlashCmdList["DroodFocusSL"] = DroodFocusSL_SlashCmd;
	
			if not DF_config then
				DF_config = DF:deepcopy(DF_pred_configs[1])
				DEFAULT_CHAT_FRAME:AddMessage(DF.locale["first"])
			end
	
			if not DF_saved_configs then
				DF_saved_configs = {}
			end
	
			if not DF_sharemedia then
				DF_sharemedia = {}
			end
	
			if not DF_talents then
				DF_talents = {}
			end
	
			if not DF_animaticsList then
				DF_animaticsList={}
			end

			if not DF_cdsList then
				DF_cdsList={}
			end

			DF:completeTable(DF_config,DF_pred_configs[1],false)
			DF:updateTable()
	
			_,DF.playerClass=UnitClass("player")
			DF:form_initStanceList()
			DF:libs_registerUsersFiles()		
			
			if not DF_config.MiniMapAngle then
				DF_config.MiniMapAngle=0
			end
		
			DF:init_frames()
			DF:toggle_toggle()
	
			DF:DF_MinimapLoad()
			DF_MinimapToggle()
			
			DF:spellslist_initTable()
			DF:cooldown_initTable()
			DF:options_createpanels()	
				
			DFeventFrame:SetScript("OnUpdate", function(self,elapsed)
				DF:OnUpdate(elapsed)
			end)			

			DFeventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			DFeventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
			DFeventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
			DFeventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")		
			DFeventFrame:RegisterEvent("ZONE_CHANGED")		
			DFeventFrame:RegisterEvent("SPELL_AURA_APPLIED")		
			DFeventFrame:RegisterEvent("SPELL_PERIODIC_DAMAGE")	
			DFeventFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")	
			DFeventFrame:RegisterEvent("PLAYER_TALENT_UPDATE")	
		
			-- reminder
			if (DF_config.configversion~=DROODFOCUS_CONFIGVERSION and DF.automaticReminder==true) then
				DF:options_show("DroodFocusMessage",nil)
			end
			
			-- màj numéro de version de la config active
			DF_config.configversion=DROODFOCUS_CONFIGVERSION

			-- bienvenue
			DEFAULT_CHAT_FRAME:AddMessage(DF.locale["welcome"])

		end
		
		DFfirstoptions=false

	elseif(eventArg == "ZONE_CHANGED") then

		SetMapToCurrentZone()

	elseif(eventArg == "PLAYER_TALENT_UPDATE") then

		DF.activeTalent = GetActiveTalentGroup()	
		
	elseif(eventArg == "PLAYER_EQUIPMENT_CHANGED") then
		
 		local slot=arg1
 		local actif=arg2
 		local slotId=nil
 		local itemId=nil
 		
 		if actif==1 then
 			if slot==13 then
 				slotId = GetInventorySlotInfo("Trinket0Slot")
 			elseif slot==14 then
 				slotId = GetInventorySlotInfo("Trinket1Slot")
 			end
 			if slotId then
 				itemId = GetInventoryItemID("player", slotId)
 				local result=DF:core_CheckItemCD(itemId)
				if result then
					if tonumber(DF_config.spells[result].abiInternalCD)>0 then
						DF:cooldown_addCD(DF_config.spells[result].ids[1],DF.currentTime,tonumber(DF_config.spells[result].abiInternalCD))
						DF_config.spells[result].abiAlert=true
					end		 		
				end		
 			end
 		end
				
	elseif(eventArg == "PLAYER_TARGET_CHANGED") then

		DF.haveTarget=UnitGUID("target")
		DF:targetbar_clearT2D()
		DF:healthbar_clearT2D()
		
	elseif(eventArg == "PLAYER_REGEN_ENABLED") then
		
		DF.menace=0
		DF:spells_clearPA()
		DF:reset_spells_list()
		DF:spells_update(60,true)
		DF:combat_set_state(false)
		DF:sound_roar()
		DF:toggle_toggle()
		DF:targetbar_clearT2D()
		DF:healthbar_clearT2D()
						
	elseif(eventArg == "PLAYER_REGEN_DISABLED") then
		
		DF:combat_set_state(true)
		DF:spells_desactivate()
		DF:toggle_toggle()
			
	elseif(eventArg == "COMBAT_LOG_EVENT_UNFILTERED") then	

   	if (arg2=="SWING_DAMAGE") then

			if (arg3==DF.playerId and arg15==1) then
				
				DF:blood_activate(0.75)
			 	
			end
		elseif (arg2=="SPELL_DAMAGE") then

			DF:sound_set_state(true)
			if (arg3==DF.playerId and arg18==1) then
	 			
				DF:blood_activate(1)
			 	
			end
			
		elseif (arg2=="SPELL_CAST_FAILED") then
		
			if (arg3==DF.playerId) then
	
				if (arg12==SPELL_FAILED_OUT_OF_RANGE) then
					DF:alert_activate("2",true)
					
				elseif (arg12==SPELL_FAILED_NOT_BEHIND) then
					DF:alert_activate("1",true)
					
				end
			end
			
		elseif  (arg2=="SPELL_INTERRUPT") then
			
			if (arg3==DF.playerId and DF_config.reportkickchan~="") then

				kickmsg=arg13.." ["..arg7.."] "..DF.locale["kicked"]
				
				if DF_config.reportkickchan=="SAY" or DF_config.reportkickchan=="YELL" then
					
					SendChatMessage( kickmsg,DF_config.reportkickchan ,nil ,nil)
					
				elseif DF_config.reportkickchan=="RAID/PARTY" then
					
					if GetNumRaidMembers()>0 then
						SendChatMessage( kickmsg,"RAID" ,nil ,nil)
					elseif GetNumPartyMembers()>0 then
						SendChatMessage( kickmsg,"PARTY" ,nil ,nil)
					end				

				elseif DF_config.reportkickchan=="PARTY" then
					
	    			if GetNumPartyMembers()>0 then
						SendChatMessage( kickmsg,"PARTY" ,nil ,nil)
					end				
					
				elseif DF_config.reportkickchan=="RAID" then
					
					if GetNumRaidMembers()>0 then
						SendChatMessage( kickmsg,"RAID" ,nil ,nil)
					end		
												
				elseif DF_config.reportkickchan=="CHAT" then
					
					DEFAULT_CHAT_FRAME:AddMessage(kickmsg)
					
				end
					
			end	
				
		elseif(arg2 == "SPELL_AURA_APPLIED") then

				if arg6==DF.playerId then
				
					if (arg12=="DEBUFF" and DF_config.alert.showDebuff) then
		
						-- le joueur viens de subir un debuff, affiche l'icone dans le système d'alert
						local name, _, imgDebuff, _, _, _, _, _, _ = GetSpellInfo(arg9);
						if imgDebuff then
							DF:alert_activate(imgDebuff,true,name,arg11,arg12)
						end
						
					elseif (arg12=="BUFF" and DF_config.alert.showBuff) then
		
						-- le joueur viens de gagner un buff, affiche l'icone dans le système d'alert
						local name, _, imgDebuff, _, _, _, _, _, _ = GetSpellInfo(arg9);
						if imgDebuff then
							DF:alert_activate(imgDebuff,true,name,arg11,arg12)
						end					
						
					end		
							
				end

		end		

	end

end

function DF:isInRaid()
	return GetNumRaidMembers()
end

-- OnUpdate
function DF:OnUpdate(elapsed)

	DF.currentTime = GetTime()

	DF:toggle_toggle()

	DF:spells_update(elapsed,true)
	
	DF:icons_update(elapsed)
	DF:timerbars_update(elapsed)
	DF:ooc_update(elapsed)

	DF:combo_update(elapsed)
	DF:arrows_update(elapsed)
	DF:alert_update(elapsed)
	DF:cooldown_update(elapsed)
	DF:infos_update(elapsed)
	DF:portrait_update(elapsed)
	DF:gps_update(elapsed)
	DF:castbar_update(elapsed)
	DF:powerbar_update(elapsed)
	DF:healthbar_update(elapsed)
	DF:manabar_update(elapsed)	
	DF:eclipsebar_update(elapsed)	
	DF:targetbar_update(elapsed)
	DF:defensebar_update(elapsed)
	DF:threatbar_update(elapsed)
	DF:blood_update(elapsed)
	DF:practice_scanner(elapsed)
	
end

function DF:toogle_lock()

	if DF.lock then
		itsok=false
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["locked"])
	else
		itsok=true
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["unlocked"])
	end
	
	DF.configmode = itsok
	
	DF:toggle_toggle()
	
	DF:anchor_toogle_lock(itsok)
	DF:powerbar_toogle_lock(itsok)
	DF:healthbar_toogle_lock(itsok)
	DF:manabar_toogle_lock(itsok)
	DF:eclipsebar_toogle_lock(itsok)
	DF:targetbar_toogle_lock(itsok)
	DF:defensebar_toogle_lock(itsok)
	DF:threatbar_toogle_lock(itsok)
	DF:combo_toogle_lock(itsok)
	DF:icons_toogle_lock(itsok)
	DF:timerbars_toogle_lock(itsok)
	DF:alert_toogle_lock(itsok)
	DF:gps_toogle_lock(itsok)
	DF:castbar_toogle_lock(itsok)
	DF:cooldown_toogle_lock(itsok)
	DF:infos_toogle_lock(itsok)
	DF:portrait_toogle_lock(itsok)
	DF:ooc_toogle_lock(itsok)
	
	DF:blood_activate(0.5)
	DF:blood_activate(1)
	DF:blood_activate(0.5)
	DF:blood_activate(1)
	
end

-- gestion ligne de commande
function DroodFocusSL_SlashCmd(arg)

	local conf=0
	
	-- parse
	if (arg==nil) then
		
		arg="";
		
	else
		
		listargs = DF:explode ( " ", string.lower(arg) );
		
		arg = string.upper(listargs[1]);

		if (listargs[2]) then
			arg2 = string.upper(listargs[2]);
		else
			arg2="";
		end
		if (listargs[3]) then
			arg3 = string.upper(listargs[3]);
		else
			arg3="";
		end	
			
	end

	-- action
	if (arg=="CONFIGMODE") then
		DF:toogle_configmode()
		
	elseif (arg=="OPTIONS") then	
		
		DF:options_show("DFOPTIONSelement")

	elseif (arg=="RESET") then	
		
		DF:config_Reset()

	elseif (arg=="BUFF") then	

		DF:ShowID("buff")
		
	elseif (arg=="DEBUFF") then	

		DF:ShowID("debuff")		
		
	elseif (arg=="SPELLS") then
	
		DF:show_spellslist()
	
	elseif (arg=="NEWS") then
	
		DF:options_show("DroodFocusMessage",nil)
			
	elseif (arg=="PRACTICE") then
	
		if DF.practiceNotRunning==false then
			DF.practiceNotRunning=true
		else
			DF.practiceNotRunning=false
		end
		DF:practice_toggle()

	elseif (arg=="CENTER") then
	
		DF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

		DF.baseanchor.base:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config["anchor0"].positionx, DF_config["anchor0"].positiony)
	
	elseif (arg=="REPORT") then

		if arg2~="NONE" and arg2~="SAY" and arg2~="YELL" and arg2~="PARTY" and arg2~="RAID" and arg2~="LOCAL" then
			DEFAULT_CHAT_FRAME:AddMessage(DF.coolName.." - /df report NONE||SAY||YELL||PARTY||RAID||LOCAL")
		else
			DEFAULT_CHAT_FRAME:AddMessage(DF.coolName.." - Report set to: "..arg2)
			if arg2=="NONE" then arg2="" end
			if arg2=="LOCAL" then arg2="CHAT" end
			DF_config.reportkickchan=arg2
		end
		
	else
		
		DEFAULT_CHAT_FRAME:AddMessage(DF.locale["commands"])
		
	end
	
end

function DF:toogle_configmode()
	
	if DF.lock then	DF.lock = false	else DF.lock = true	end
	DF:toogle_lock()
	
end

function DF:ShowID(ftype)

	DF:debugLine("Begin list of ",ftype)		

	local index=1
	while true do 

		if ftype=="buff" then
			
			name, _, _, _, debuffType, _, _, unitCaster, _, _, spellId = UnitAura("player", index, "HELPFUL") 
		
		elseif ftype=="debuff" then
			
			name, _, _, _, debuffType, _, _, unitCaster, _, _, spellId = UnitAura("playertarget", index, "HARMFUL") 
		
		else
		
			name=nil
		
		end

		if not name then break end

		DF:debugLine(ftype.." "..tostring(index)..": "..tostring(name),spellId)		
		
		index=index+1
		
	end
	DF:debugLine("End list of ",ftype)
end

-- démarrage
DF:setUp()